Package org.springframework.aop.support

# Class AbstractExpressionPointcut

java.lang.Object
org.springframework.aop.support.AbstractExpressionPointcut

All Implemented Interfaces:
  `Serializable`, `Pointcut`, `ExpressionPointcut`

Direct Known Subclasses:
  `AspectJExpressionPointcut`

public abstract class AbstractExpressionPointcut extends Object implements ExpressionPointcut, Serializable
Abstract superclass for expression pointcuts, offering location and expression properties.

Since:
  2.0
Author:
  Rod Johnson, Rob Harrop
See Also:
  - `setLocation(java.lang.String)`
  - `setExpression(java.lang.String)`
  - Serialized Form

## Field Summary

### Fields inherited from interface org.springframework.aop.Pointcut

`TRUE`

## Constructor Summary

Constructors
Constructor
Description
`AbstractExpressionPointcut()`

## Method Summary

Modifier and Type
Method
Description
`String`
`getExpression()`
Return this pointcut's expression.
`String`
`getLocation()`
Return location information about the pointcut expression if available.
`protected void`
`onSetExpression(String expression)`
Called when a new pointcut expression is set.
`void`
`setExpression(String expression)`
`void`
`setLocation(String location)`
Set the location for debugging.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.springframework.aop.Pointcut

`getClassFilter, getMethodMatcher`

## Constructor Details

### AbstractExpressionPointcut

public AbstractExpressionPointcut()

## Method Details

### setLocation

public void setLocation(@Nullable String location)
Set the location for debugging.

### getLocation

@Nullable public String getLocation()
Return location information about the pointcut expression if available. This is useful in debugging.

Returns:
  location information as a human-readable String, or `null` if none is available

### setExpression

public void setExpression(@Nullable String expression)

### onSetExpression

protected void onSetExpression(@Nullable String expression) throws IllegalArgumentException
Called when a new pointcut expression is set. The expression should be parsed at this point if possible.

This implementation is empty.

Parameters:
  `expression` - the expression to set
Throws:
  `IllegalArgumentException` - if the expression is invalid
See Also:
  - `setExpression(java.lang.String)`

### getExpression

@Nullable public String getExpression()
Return this pointcut's expression.

Specified by:
  `getExpression` in interface `ExpressionPointcut`